/*	______________________________________________________________________

	imagepak.h  Version 1.00
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	ImagePak -      
	______________________________________________________________________
*/
#ifndef _IMGPAK_
#define _IMGPAK_ 

#include <stdio.h>
#include <math.h>

#define PI 3.14159265358979323846

struct F_LINE
{
	int k1;
	int b;
	double b1,b2;
};

struct C_POINT
{
	int x,y;
};

struct C_POINTd
{
	double x,y;
};

//   4 
/*
0 ----- 2
|       |
3 ----- 1
*/
struct FOUR_FIG_P
{
	C_POINT p[4];//0,1  -   2,3 - 
};

struct FOUR_FIG_Pd
{
	C_POINTd p[4];//0,1  -   2,3 - 
};

//   4 
//   02-21-13-30
struct FOUR_FIG_L
{
	F_LINE l[4];
};


//   
F_LINE MakeLine(double x1,double y1,double x2,double y2);
F_LINE MakeLine(C_POINT p1,C_POINT p2);
F_LINE MakeLine(C_POINTd p1,C_POINTd p2);
extern "C"
{
F_LINE MakeLineFromPolar(C_POINTd p1,double f);
}
//        (    ) 
C_POINTd FindPointContinue(C_POINTd p1,C_POINTd p2,F_LINE line,double size);
C_POINTd FindPointContinue_(C_POINTd p1,C_POINTd p2,F_LINE line,double size);

extern "C"
{

int Intersection(F_LINE f1,F_LINE f2,double &x,double &y);//  

//   
double LengthLine(double x1,double y1,double x2,double y2);

// 
float MakePolarR(float x,float y);
float MakePolarF(float x,float y);

#define DIRECT_HOUR_ARROW 0x01	// 
#define DIRECT_HOUR_ARROW_A 0x02	//
//   -     
bool DirectPoint(C_POINT*p,int all,unsigned char flags);

C_POINTd PointID(C_POINT p);
C_POINT PointDI(C_POINTd p);

}

double RToLine(F_LINE f,double x,double y);//    
double RToLine(F_LINE f,C_POINTd p);

extern "C"
{

int round(double param);
double absf(double a);


//  
C_POINTd Average(C_POINTd p1,C_POINTd p2);

//  
F_LINE MakeParallelLine(F_LINE line,C_POINTd point);

//        
double FoundInclination(F_LINE line,F_LINE line1);

//     
F_LINE TurnLine(F_LINE f,double alfa,C_POINTd point);

}

#include <windows.h>
#include <olectl.h>

#define THRESH_BINARY_INV		1
#define ALLOCATE_WHITE			1

//  24  
struct IMG
{
	byte* bytes;
	int Width;
	int Width_1;
	int Height;
	bool on;
	//    ,    -  24 
	BYTE format;//0 - 24 1 - 8   
};

extern "C"
{

IMG OpenDF(char* filename);

}

int DrawLine(IMG img,F_LINE,byte c1,byte c2,byte c3);
int DrawLine(IMG img, C_POINT p1,C_POINT p2,byte c1,byte c2,byte c3);

extern "C"
{

int DrawRect(IMG img,RECT rect,byte c1,byte c2,byte c3);


//  
int UpDownImage(IMG img);

// jpeg,gif  bmp
HBITMAP  LoadPictureFile(LPCTSTR szFile);
IMG OpenGraphFile(char* filename);
int  SaveDF(char* filename,IMG img);
// 
int CopyIMG(IMG in,IMG &out);

//
IMG Transform1(IMG Img);


//  
void  ThresholdImage(IMG Img,byte param,RECT rect);
IMG AdaptiveThresholdImage(IMG Img,int block_size,RECT rect,DWORD flags);
void  Adaptive2ThresholdImage(IMG Img,byte param,byte delta,RECT rect,int pixels);

// 
void AllocationBorders(IMG img);
void AllocationBordersRect(IMG img,RECT r, DWORD flags);

//      
IMG ReduceImage(IMG img,int param);

//  8  
IMG  Img24To8(IMG Img);

//  24 
IMG  Img8To24(IMG Img);

// 
void ClearImage(IMG img);

// 
void DrawPoint(IMG img,int x,int y,byte c1,byte c2,byte c3);

//     3  3
IMG  Img_Dilate(IMG Img);

//
IMG  Img_Erode(IMG Img);

}

class GRID
{
private:
	int x_size,y_size;
	FOUR_FIG_Pd main_p;
	FOUR_FIG_L main_l;
	//FOUR_FIG_P* p;
	F_LINE* l;
	double* cells;//   
public:
	GRID(int x,int y);//       
	~GRID();//
	int CreateGrid(FOUR_FIG_P pp);//       
	int CreateGrid(FOUR_FIG_Pd pp);//       
	F_LINE GetLine(int num);//   
	int RecogCells(IMG img);//   8-  
#ifdef ON_DEBUG
	int RecogCells(IMG img,IMG img24);//   8-  
#endif
	int ReturnBlackCells(double delta);//  -  ,    delta (0-, 1 - )
	void ReturnGrid(double delta,bool &array);//   1-  0 -	
	void ReturnGrid1(double delta,bool &array);// ,    Aztec 
};

extern "C"
{

int ReturnCountBlackPoints(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points);
int ReturnCountBlackPointsBr(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points,C_POINTd &border);



F_LINE AccuracyLine(IMG img,F_LINE base_line,C_POINTd point,double alfa,int steps,double Step_line);
int BlackWhite(IMG img,int j,int x,int y);
int OnBlackWhite(IMG img,double x1,double y1,double x2,double y2,F_LINE f3);


#define MAX_DETECTED_CODE 10

int DetectCode(IMG image_code,int reduce,int &AllDetectedCode,RECT *DetectedCode);


}

//    
#define MAX_CONTOUR 10000

//
#define CONTOUR_AUTO_INOUT				0x01     //    



struct CONTOUR_STRUCT
{
	WORD all_elem;//     
	C_POINT* Points;//   
	RECT Zone;// 
	int mama;//  -1,   
	int level;// 
};


class  CONTOUR
{
private:
	int all_contour;
	CONTOUR_STRUCT Contours[MAX_CONTOUR];

	int all_elem;
	C_POINT *Point;
	RECT Zone;
	void FindBorderPoint(int x,int y);
	byte c1;
	RECT rect;
	//  
	IMG Image;
public:
	CONTOUR();
	~CONTOUR();
	int Find(IMG img,RECT rect,byte c,DWORD flags);//     8 
	int DrawContour(IMG img,int num_counter,byte c1,byte c2,byte c3);// 
	int DrawContours(IMG img,byte c1,byte c2,byte c3);//  
	void ReturnMaxLevel(int &level,int &first,int &all);//         

	C_POINT ReturnCenterContour(int num_con);//  
	bool ReturnPointInContour(C_POINT c,int num_contour);//       
	int GetMama(int num_contour);//  
	int Return4DistantPoints(C_POINT &c_p,int num_contour);// 4      
	int PointsInLine(F_LINE line,int num_contour);//    
	int AllPoints(int num_contour);//  all_elem
	//int MakeSequence(int num_contour);//   
	int Accuracy4RombPoints(C_POINT &c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour);// 4    Return4DistantPoints
};

extern "C"
{

void  DeleteByte(unsigned char*pointer);

}

#endif